Freeciv-3.2: /fast/freeciv/nightly/S3_2/client/gui-sdl2/canvas.c File Reference

Freeciv-3.2

Loading...
Searching...
No Matches
Functions
canvas.c File Reference
`#include <SDL2/SDL.h>`
`#include <SDL2/SDL_ttf.h>`
`#include "log.h"`
`#include "mem.h"`
`#include "colors.h"`
`#include "graphics.h"`
`#include "gui_main.h"`
`#include "gui_string.h"`
`#include "sprite.h"`
`#include "canvas.h"`

Go to the source code of this file.

## Functions

struct canvas * | canvas_create (int width, int height)
void | canvas_free (struct canvas *store)
void | canvas_set_zoom (struct canvas *store, float zoom)
bool | has_zoom_support (void)
void | canvas_mapview_init (struct canvas *store)
void | canvas_copy (struct canvas *dest, struct canvas *src, int src_x, int src_y, int dest_x, int dest_y, int width, int height)
void | canvas_put_sprite (struct canvas *pcanvas, int canvas_x, int canvas_y, struct sprite *sprite, int offset_x, int offset_y, int width, int height)
void | canvas_put_sprite_full (struct canvas *pcanvas, int canvas_x, int canvas_y, struct sprite *sprite)
void | canvas_put_sprite_full_scaled (struct canvas *pcanvas, int canvas_x, int canvas_y, int canvas_w, int canvas_h, struct sprite *sprite)
void | canvas_put_sprite_fogged (struct canvas *pcanvas, int canvas_x, int canvas_y, struct sprite *psprite, bool fog, int fog_x, int fog_y)
void | canvas_put_rectangle (struct canvas *pcanvas, struct color *pcolor, int canvas_x, int canvas_y, int width, int height)
void | canvas_fill_sprite_area (struct canvas *pcanvas, struct sprite *psprite, struct color *pcolor, int canvas_x, int canvas_y)
void | canvas_put_line (struct canvas *pcanvas, struct color *pcolor, enum line_type ltype, int start_x, int start_y, int dx, int dy)
void | canvas_put_curved_line (struct canvas *pcanvas, struct color *pcolor, enum line_type ltype, int start_x, int start_y, int dx, int dy)
void | get_text_size (int *width, int *height, enum client_font font, const char *text)
void | canvas_put_text (struct canvas *pcanvas, int canvas_x, int canvas_y, enum client_font font, struct color *pcolor, const char *text)

## Function Documentation

## ◆ canvas_copy()

void canvas_copy | ( | struct canvas * | dest,
|  | struct canvas * | src,
|  | int | src_x,
|  | int | src_y,
|  | int | dest_x,
|  | int | dest_y,
|  | int | width,
|  | int | height
| ) |  |

Copies an area from the source canvas to the destination canvas.

Definition at line 89 of file canvas.c.

## ◆ canvas_create()

struct canvas * canvas_create | ( | int | width,
|  | int | height
| ) |  |

Create a canvas of the given size.

Definition at line 43 of file canvas.c.

## ◆ canvas_fill_sprite_area()

void canvas_fill_sprite_area | ( | struct canvas * | pcanvas,
|  | struct sprite * | psprite,
|  | struct color * | pcolor,
|  | int | canvas_x,
|  | int | canvas_y
| ) |  |

Fill the area covered by the sprite with the given color.

Definition at line 174 of file canvas.c.

## ◆ canvas_free()

void canvas_free | ( | struct canvas * | store | ) |

Free any resources associated with this canvas and the canvas struct itself.

Definition at line 56 of file canvas.c.

## ◆ canvas_mapview_init()

void canvas_mapview_init | ( | struct canvas * | store | ) |

Initialize canvas as mapview.

Definition at line 81 of file canvas.c.

## ◆ canvas_put_curved_line()

void canvas_put_curved_line | ( | struct canvas * | pcanvas,
|  | struct color * | pcolor,
|  | enum line_type | ltype,
|  | int | start_x,
|  | int | start_y,
|  | int | dx,
|  | int | dy
| ) |  |

Draw a 1-pixel-width colored curved line onto the canvas.

Definition at line 202 of file canvas.c.

## ◆ canvas_put_line()

void canvas_put_line | ( | struct canvas * | pcanvas,
|  | struct color * | pcolor,
|  | enum line_type | ltype,
|  | int | start_x,
|  | int | start_y,
|  | int | dx,
|  | int | dy
| ) |  |

Draw a 1-pixel-width colored line onto the canvas.

Definition at line 192 of file canvas.c.

## ◆ canvas_put_rectangle()

void canvas_put_rectangle | ( | struct canvas * | pcanvas,
|  | struct color * | pcolor,
|  | int | canvas_x,
|  | int | canvas_y,
|  | int | width,
|  | int | height
| ) |  |

Draw a filled-in colored rectangle onto canvas.

Definition at line 159 of file canvas.c.

## ◆ canvas_put_sprite()

void canvas_put_sprite | ( | struct canvas * | pcanvas,
|  | int | canvas_x,
|  | int | canvas_y,
|  | struct sprite * | sprite,
|  | int | offset_x,
|  | int | offset_y,
|  | int | width,
|  | int | height
| ) |  |

Draw some or all of a sprite onto the canvas.

Definition at line 102 of file canvas.c.

## ◆ canvas_put_sprite_fogged()

void canvas_put_sprite_fogged | ( | struct canvas * | pcanvas,
|  | int | canvas_x,
|  | int | canvas_y,
|  | struct sprite * | psprite,
|  | bool | fog,
|  | int | fog_x,
|  | int | fog_y
| ) |  |

Draw a full sprite onto the canvas. If "fog" is specified draw it with fog.

Definition at line 142 of file canvas.c.

## ◆ canvas_put_sprite_full()

void canvas_put_sprite_full | ( | struct canvas * | pcanvas,
|  | int | canvas_x,
|  | int | canvas_y,
|  | struct sprite * | sprite
| ) |  |

Draw a full sprite onto the canvas.

Definition at line 116 of file canvas.c.

## ◆ canvas_put_sprite_full_scaled()

void canvas_put_sprite_full_scaled | ( | struct canvas * | pcanvas,
|  | int | canvas_x,
|  | int | canvas_y,
|  | int | canvas_w,
|  | int | canvas_h,
|  | struct sprite * | sprite
| ) |  |

Draw a full sprite onto the canvas, scaled to the canvas size.

Definition at line 128 of file canvas.c.

## ◆ canvas_put_text()

void canvas_put_text | ( | struct canvas * | pcanvas,
|  | int | canvas_x,
|  | int | canvas_y,
|  | enum client_font | font,
|  | struct color * | pcolor,
|  | const char * | text
| ) |  |

Draw the text onto the canvas in the given color and font. The canvas position does not account for the ascent of the text; this function must take care of this manually. The text will not be NULL but may be empty.

Definition at line 242 of file canvas.c.

## ◆ canvas_set_zoom()

void canvas_set_zoom | ( | struct canvas * | store,
|  | float | zoom
| ) |  |

Set canvas zoom for future drawing operations.

Definition at line 65 of file canvas.c.

## ◆ get_text_size()

void get_text_size | ( | int * | width,
|  | int * | height,
|  | enum client_font | font,
|  | const char * | text
| ) |  |

Return the size of the given text in the given font. This size should include the ascent and descent of the text. Either of width or height may be NULL in which case those values simply shouldn't be filled out.

Definition at line 215 of file canvas.c.

## ◆ has_zoom_support()

bool has_zoom_support | ( | void |  | ) |

This gui has zoom support.

Definition at line 73 of file canvas.c.